package pl.edu.pwr.examples;

import java.util.ArrayList;
import java.util.List;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class StudentDaoImpl implements StudentDao {
	private Connection conn = null;

	static {
		try {
			Class.forName("org.sqlite.JDBC"); 
		} catch (ClassNotFoundException e) {

			System.out.println(e.getMessage());

		}
	}

	public StudentDaoImpl() {
	}

	private void connect() throws SQLException {
		if (conn != null)
			return;
		String url = "jdbc:sqlite:test.db";
		conn = DriverManager.getConnection(url);
	}

	private void disconnect() throws SQLException {
		if (conn == null)
			return;
		conn.close();
		conn = null;
	}

	@Override
	public void deleteStudent(Student s) {

		String sql = "DELETE FROM students WHERE rollNo=?";
		try {
			connect();
			PreparedStatement pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, s.getRollNo());
			pstmt.executeUpdate();
			disconnect();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	// retrive list of students from the database
	@Override
	public List<Student> getAllStudents() {
		String sql = "SELECT name, rollNo FROM students";
		List<Student> list = new ArrayList<>();
		try {
			connect();
			Statement stmt = conn.createStatement();
			ResultSet resultSet = stmt.executeQuery(sql);
			while (resultSet.next())
				list.add(new Student(resultSet.getString("name"), resultSet.getInt("rollNo")));
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return list;
	}

	@Override
	public Student getStudent(int rollNo) {
		String sql = "SELECT name FROM students WHERE rollNo=?";
		Student s = null;
		try {
			connect();
			PreparedStatement pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, rollNo);
			ResultSet rs = pstmt.executeQuery();
			if (rs.next()) {
				s = new Student(rs.getString("name"), rollNo);
			}
			pstmt.close();
			disconnect();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return s;
	}

	@Override
	public void updateStudent(Student s) {
		String sql = "UPDATE students SET name = ? " + "WHERE rollNo = ?";

		try {
			connect();
			PreparedStatement pstmt = conn.prepareStatement(sql);
			pstmt.setString(1, s.getName());
			pstmt.setInt(2, s.getRollNo());
			pstmt.executeUpdate();
			pstmt.close();
			disconnect();
		} catch (SQLException e) {
			System.out.println(e.getMessage());
		}
	}

	@Override
	public void addStudent(Student s) {
		String sql = "INSERT INTO students(name,rollNO) VALUES (?,?)";

		try {
			connect();
			PreparedStatement pstmt = conn.prepareStatement(sql);
			pstmt.setString(1, s.getName());
			pstmt.setInt(2, s.getRollNo());
			pstmt.executeUpdate();
			pstmt.close();
		} catch (SQLException e) {
			System.out.println(e.getMessage());
		}
	}
}
